<?php

namespace App\Http\Controllers;

use App\Events\RegistrarPagoEvent;
use App\Helpers\Helpers;
use App\Models\Bnb;
use App\Models\ImagenQr;
use App\Models\Qr;
use App\Models\Pago;
use Carbon\Carbon;
use DateTime;
use DateTimeZone;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Validator;
use Vdhicts\ValidationRules\Rules\DateHasSpecificMinutes;

class BnbController extends Controller
{
    //
    public function obtener_token(Request $request)
    {

        $token = Helpers::tokenAuthBnb();

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        // dd($token);
        return response()->json($tokenData, 200);

        //*************fin funca************* */

    }

    public function obtener_imageQr(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
                    "currency" => "BOB",
                    "gloss" => "pago QR4",
                    "amount" => 10,
                    "singleUse" => true,
                    "expirationDate" => $fecha,
                    "additionalData" => "Datos Adicionales para identificar el QR1111",
                    "destinationAccountId" => "1"
                ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function obtener_imageQrGeneradosporFecha(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRbyGenerationDateAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
                    "generationDate" => $fecha
                ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function obtener_estado_imageQr($id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRStatusAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
                    "qrId" => $id
                ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function cancelar_estado_imageQr($id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');

        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/CancelQRByIdAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
                    "qrId" => $id
                ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function crear_notificacion(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $date = date('s');
        //  $segundos =
        //$todayDate = date("d\/m\/Y H:i:s");
        $todayDate = Carbon::now()->timeZone('America/La_Paz')->format('d/m/Y H:i:s');

        $validator = Validator::make($request->all(), [
            'QRId' => 'required|unique:bnbs,QRId',
            'sourceBankId' => 'required|integer|gt:0',
            'originName' => 'required|string',
            // 'VoucherId' => 'required|unique:bnbs,VoucherId',
            // "TransactionDateTime" => 'required|date_format:d/m/Y nullable|date_equals:' . $todayDate,
            //  "TransactionDateTime" => 'date_format:d/m/Y H:i:s|date_equals:' . $todayDate . '|required',
        ]);


        if ($validator->stopOnFirstFailure()->fails()) {
            // $message = ;
            $message = json_encode([
                "success" => false,
                "message" => $validator->errors()->first(),
            ]);

            return response()->json(
                json_decode($message),

                //[
                // 'VoucherId.required' => 'EL VoucherId es requerido',
                // 'VoucherId.unique' => 'EL VoucherId es un campo único',
                // 'TransactionDateTime.required' => 'La fecha es requerida',
                // 'TransactionDateTime.date_format' => 'El formato de la fecha es Año-mes-dia',
                // 'TransactionDateTime.date_equals' => 'La fecha is incorrecta, tiene que tener la fecha de hoy'


                //],
                200
            );
        }

        DB::beginTransaction();
        try {
            //  $imageQr = ImagenQr::select('qrId', 'numeroFactura', 'customID', 'id_wispro', 'state', 'idfactura', 'qr_id')->where("qrId", $request->QRId)->get();

            //if (count($imageQr) > 0) {
            // $random_date = '01/01/2017';
            $random_date = $request->TransactionDateTime;
            $random_date = str_replace('/', '-', $random_date);
            //create an object of DateTime 
            $date = new DateTime($random_date);
            //Format the date to the format you need 
            //Y for full year (1993 or 2000 or 2017) 
            //m for month with leading 0 (01-09 and 10-12) 
            //d for date with leading 0 (0-9 and 10 to 31) 
            //H:i:s is optional 
            $date = $date->format('Y-m-d H:i:s');
            /*
            return response()->json([
                'success' => true,
                'QRId' => $request->QRId,
                'Gloss' => $request->Gloss,
                'sourceBankId' => $request->sourceBankId,
                'originName' => $request->originName,
                'VoucherId' => $request->VoucherId,
                'TransactionDateTime' => $date,
                'additionalData' => $request->additionalData,
                'message' => 'OK',

            ], 200, [], JSON_UNESCAPED_UNICODE);*/
            // guardar en la BD
            /*      
                      $bnb = new Bnb();
                      $bnb->QRId = $request->QRId;
                      $bnb->Gloss = $request->Gloss;
                      $bnb->sourceBankId = $request->sourceBankId;
                      $bnb->originName = $request->originName;
                      $bnb->VoucherId = $request->VoucherId;
                      $bnb->TransactionDateTime = $date; //$request->TransactionDateTime;
                      $bnb->additionalData = $request->additionalData;
                      $bnb->save();
          */

            // verificamos si el qrId hasido pagado
            $authBnb = Helpers::tokenAuthBnb();
            $success = $authBnb['success'];
            $tokenBnb = $authBnb['message'];
            if ($success) {
                $statusQrBnb = Helpers::statusQrBnb($tokenBnb, $request->QRId);
                $statusId = $statusQrBnb['statusId'];
                if ($statusId == 1) {
                    $bnb = Bnb::create([
                        'QRId' => $request->QRId,
                        'Gloss' => $request->Gloss,
                        'sourceBankId' => $request->sourceBankId,
                        'originName' => $request->originName,
                        'VoucherId' => $request->VoucherId,
                        'TransactionDateTime' => $date,
                        'additionalData' => $request->additionalData,
                    ]);
                    DB::commit();
                    RegistrarPagoEvent::dispatch($bnb);
                    return response()->json([
                        'success' => true,
                        'message' => 'OK',
                        //    'bnb' => $pago,

                    ], 200, [], JSON_UNESCAPED_UNICODE);
                }
                return $statusId;
            } else {
                return 'error';
            }







        } catch (\Exception $e) {
            DB::rollBack();

            return response()->json([
                "success" => false,
                //"fecha" => $request->TransactionDateTime,
                // "fecha2" => $ldate,
                //"hola" => $date,
                //"dt" => $dt,

                "message" => "Error al crear la notificacion." . $e


            ], 200);
        }
        // return response()->json([
        //     'success' => false,
        //     'mensaje'
        // ], 422);
    }


}