<?php

namespace App\Http\Controllers;

use App\Events\RegistrarPagoEvent;
use App\Helpers\Helpers;
use App\Models\Bnb;
use App\Models\Client;
use App\Models\ErrorQr;
use App\Models\Factura;
use App\Models\ImagenQr;
use App\Models\Qr;
use App\Models\Pago;
use App\Models\PagoWispro;
use App\Models\Plan;
use Carbon\Carbon;
use DateTime;
use DateTimeZone;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Validator;
use Vdhicts\ValidationRules\Rules\DateHasSpecificMinutes;
use Illuminate\Support\Facades\Log;

class BnbController extends Controller
{
    //
    public function obtener_token(Request $request)
    {

        $token = Helpers::tokenAuthBnb();

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        // dd($token);
        return response()->json($tokenData, 200);

        //*************fin funca************* */

    }

    public function obtener_imageQr(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
            "currency" => "BOB",
            "gloss" => "pago QR4",
            "amount" => 10,
            "singleUse" => true,
            "expirationDate" => $fecha,
            "additionalData" => "Datos Adicionales para identificar el QR1111",
            "destinationAccountId" => "1"
        ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function obtener_imageQrGeneradosporFecha(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRbyGenerationDateAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
            "generationDate" => $fecha
        ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function obtener_estado_imageQr($id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRStatusAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
            "qrId" => $id
        ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function cancelar_estado_imageQr($id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');

        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/CancelQRByIdAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
            "qrId" => $id
        ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
    }
    public function crear_notificacion(Request $request)
    {

        Log::info("crear_notificacion ::> QRId==>" . $request->QRId . " fecha==>" . now());
        date_default_timezone_set('America/La_Paz');
        $date = date('s');
        $fechaHoraError = date('d-m-Y h:i:s');

        //  $segundos =
        //$todayDate = date("d\/m\/Y H:i:s");
        $todayDate = Carbon::now()->timeZone('America/La_Paz')->format('d/m/Y H:i:s');
        ///////

        $validator = Validator::make($request->all(), [
            'QRId' => 'required|unique:bnbs,QRId',
            'sourceBankId' => 'required|integer|gt:0',
            'originName' => 'required|string',
            // 'VoucherId' => 'required|unique:bnbs,VoucherId',
            // "TransactionDateTime" => 'required|date_format:d/m/Y nullable|date_equals:' . $todayDate,
            //  "TransactionDateTime" => 'date_format:d/m/Y H:i:s|date_equals:' . $todayDate . '|required',
        ]);


        if ($validator->stopOnFirstFailure()->fails()) {
            // $message = ;
            $message = json_encode([
                "success" => false,
                "message" => $validator->errors()->first(),
            ]);

            return response()->json(
                json_decode($message),

                //[
                // 'VoucherId.required' => 'EL VoucherId es requerido',
                // 'VoucherId.unique' => 'EL VoucherId es un campo único',
                // 'TransactionDateTime.required' => 'La fecha es requerida',
                // 'TransactionDateTime.date_format' => 'El formato de la fecha es Año-mes-dia',
                // 'TransactionDateTime.date_equals' => 'La fecha is incorrecta, tiene que tener la fecha de hoy'


                //],
                200
            );
        }


        //////      
        /*      
        $fechaActual = date('d-m-Y');
        $fechaHoraError = date('d-m-Y h:i:s');
        $fechaLimitePromesaPago = date('10-m-Y');
        // fecha para crear promesa de pago
        $fechaInicioPromesaPago = strtotime($fechaLimitePromesaPago);
        $fechaActu = strtotime($fechaActual);
*/
        // DB::beginTransaction();
        //  try {
        /*
            $qrr = Qr::where("qr_id", $request->QRId)->count();
        if ($qrr > 0) {
            $qrr = Qr::where("qr_id", $request->QRId)->first();
            $clientID = $qrr->client_id;
            $client = Client::where("id", $clientID)->first();
            $clienteNroCi = $client->national_identification_number;

            $authBnb = Helpers::tokenAuthBnb();
            $success = $authBnb['success'];
            $tokenBnb = $authBnb['message'];
            if ($success) {
                $statusQrBnb = Helpers::statusQrBnb($tokenBnb, $request->QRId);
                $statusId = $statusQrBnb['statusId'];
                if ($statusId == 1) {
                    $plan = Plan::find(1);
                    $qrr = Qr::where("qr_id", $request->QRId)->first();
                    $imageQr = ImagenQr::where("qr_id", $qrr->id)->first();

                    $facturas = Factura::where("imagen_qr_id", $imageQr->id)->get();
                    $ids = [];

                    if (count($facturas) > 0) {
                        foreach ($facturas as $factura) {

                            $monto = 0;
                            $ids = [];
                            $pagosWispros = PagoWispro::select('id_invoice', 'amount', 'cliente_uuid')->where("factura_id", $factura->id)->get()->all();
                            $cont = count($pagosWispros);
                            foreach ($pagosWispros as $pagosWis) {
                                $client_id = $pagosWis->cliente_uuid;
                                $monto = $monto + floatval($pagosWis->amount);
                                $ids[] = $pagosWis->id_invoice;
                            }
                            // $invoice[] = [$ids, $client_id, $monto];
                            $comment = 'Pago por QR en ' . $fechaActual;
                            $estadoContrato = Helpers::pageInvoice($client_id, $ids, $monto, $comment);

                            // Elimnar de la BBDD
                            Pago::Create([
                                'QRId' => $request->QRId,
                                'Gloss' => $request->Gloss,
                                'sourceBankId' => $request->sourceBankId,
                                'originName' => $request->originName,
                                'VoucherId' => $request->VoucherId,
                                'TransactionDateTime' => $request->TransactionDateTime,
                                'additionalData' => $request->additionalData,
                                'monto' => $factura->amount,
                                //$factura->amount,
                                //$event->$qrr->amount,
                                'numeroFactura' => $factura->numeroFactura,
                                //$factura->numeroFactura,
                                //$event->bnb->id,
                                'client_id' => $factura->client_id //$event->bnb->id,
                            ]);
                            $estadoYprecio = Helpers::obtenerEstadoDelContratosXuuid($client_id);

                            if ($estadoYprecio['precio'] > $plan->precio) {
                                Helpers::habilitar_cattv($factura->custom_id);
                            }
                            // crea promesa de pago
                            if (isset($factura->numeroFactura)) {
                                // para generar la promesa de pago
                                if ($fechaActu > $fechaInicioPromesaPago) {
                                    // crear promesa de pago
                                    $response_token = Helpers::crearPromesasPago($estadoYprecio['id']); //$uuidContrato);
                                }
                            }
                            // eliminamos de la BBDD

                            //array_push($invoice_ids2, $pagosWispros);
                        }
                        //Actualizamos tabla ImageQR              
                        // $imaqr = ImagenQr::find($imageQr->id);
                        // $imaqr = ImagenQr::where('', '=', $imageQr->id)->get();
                        // $imaqr = ImagenQr::all();


                        // $imaqr = ImagenQr::where('custom_id'$imageQr->id);
                        ImagenQr::where('montoMes', '=', $imageQr->montoMes)
                            ->where('custom_id', '=', $imageQr->custom_id)
                            ->where('periodo', '=', $imageQr->periodo)
                            ->update([
                                'activo' => 2,
                                // 'statusId' => $statusId,
                            ]);
                        $imaqr2 = ImagenQr::find($imageQr->id);
                        $imaqr2->estado = 1; //pagado
                        $imaqr2->statusId = $statusId;
                        $imaqr2->activo = 1; //1= activo muestra 2=Inactivo No muestra
                        $imaqr2->update();

                        //colocando estado a 1 a las facturas que fueron pagadas
                        Factura::where('imagen_qr_id', '=', $qrr->id)
                            ->update([
                                'estado' => 1,
                            ]);


                        $facturasPendientes = Helpers::facturasPendientes($clienteNroCi);
                        $facturasPendientes = $facturasPendientes['meta'];
                        $facturasPendientes = $facturasPendientes['pagination'];
                        $factPendientes = $facturasPendientes['total_records'];
                        if ($factPendientes == 0) {
                            $imaqr = ImagenQr::find($imageQr->id);
                            ImagenQr::where('periodo', '=', $imaqr->periodo)
                                ->where('activo', '!=', 1)
                                ->update([
                                    'activo' => 2,
                                    // 'statusId' => $statusId,
                                ]);
                        }
                        //Actualizacion tabla facturas
                        // $factura = Factura::find($imaqr->id);
                        // $factura->estado = 1;
                        // $factura->update();
                        return response()->json([
                            'success' => true,
                            'message' => 'OK',
                            //    'bnb' => $pago,

                        ], 200, [], JSON_UNESCAPED_UNICODE);
                    }
                } else {
                    //TODO registrar el evento por que no se pago
                    $imageQr = ImagenQr::find($qrr->id);

                    $imageQr->statusId = $statusId;
                    $imageQr->mensaje = $statusQrBnb['message'];
                    $imageQr->update();
                    return response()->json([
                        'success' => true,
                        'message' => 'Image QR actualizado',
                        //    'bnb' => $pago,

                    ], 200, [], JSON_UNESCAPED_UNICODE);
                }
            } else {
                return 'error';
            }
        }
        */
        /*
        } catch (\Exception $e) {
            DB::rollBack();
            $errorQr = new ErrorQr();
            $errorQr->qrid = $event->bnb->QRId;
            $errorQr->originName = $event->bnb->originName;
            $errorQr->error = $e;
            $errorQr->TransactionDateTime = $fechaHoraError;
            $errorQr->save();
            return response()->json([
                "success" => false,

                "message" => "Error al registrar el Pago del QR. en el sistema" . $e
            ], 422);
        }
*/

        DB::beginTransaction();
        try {

            $random_date = $request->TransactionDateTime;
            $random_date = str_replace('/', '-', $random_date);
            //create an object of DateTime 
            $date = new DateTime($random_date);
            //Format the date to the format you need 
            //Y for full year (1993 or 2000 or 2017) 
            //m for month with leading 0 (01-09 and 10-12) 
            //d for date with leading 0 (0-9 and 10 to 31) 
            //H:i:s is optional 
            $date = $date->format('Y-m-d H:i:s');


            $bnb = Bnb::create([
                'QRId' => $request->QRId,
                'Gloss' => $request->Gloss,
                'sourceBankId' => $request->sourceBankId,
                'originName' => $request->originName,
                'VoucherId' => $request->VoucherId,
                'TransactionDateTime' => $date,
                'additionalData' => $request->additionalData,
            ]);
            Log::info("crear_notificacion ::> QRId==>" . $request->QRId . " fecha==>" . now());
            RegistrarPagoEvent::dispatch($bnb);
            DB::commit();
            return response()->json([
                'success' => true,
                'message' => 'OK',
                //    'bnb' => $pago,

            ], 200, [], JSON_UNESCAPED_UNICODE);
        } catch (\Exception $e) {
            Log::channel('errorpagoSintesis')->info("---------------------------" . now() . "---------------------------");
            Log::channel('errorpagoSintesisBNB')->info("error: " - $e);
            DB::rollBack();
            $errorQr = new ErrorQr();
            $errorQr->qrid = $request->QRId;
            $errorQr->originName = $request->originName;
            $errorQr->error = $e;
            $errorQr->TransactionDateTime = $fechaHoraError;
            $errorQr->save();
            return response()->json([
                "success" => false,

                "message" => "Error al crear la notificacion." . $e
            ], 422);
        }
    }
}
