<?php

namespace App\Http\Controllers;

use App\Models\Plan;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;

class PlanController extends Controller
{
    //
    public function index()
    {
        //
        $this->authorize("viewAny_user");

        // $usuarios = User::with('roles')->paginate(10);
        // $usuarios = User::paginate(10);
        $plan = Plan::get();
        return response()->json([
            "status" => true,
            "plan" => $plan
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //


        $this->authorize("create_user");

        // validar
        $request->validate([
            "nombre" => "required",
            "page" => "required",
            "mensaje" => "required"
        ]);
        // guardar como objeto
        $mensaje = new Plan();
        $mensaje->nombre = $request->nombre;
        $mensaje->page = $request->page;
        $mensaje->mensaje = $request->mensaje;

        $mensaje->save();
        // responder
        return response()->json([
            "status" => true,
            "plan" => "Plan registrado correctamente"
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
        $this->authorize("show_user");

        $plan = Plan::find($id);

        return response()->json([
            "status" => true,
            "usuario" => $plan
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
        //  $this->authorize("update_user");
        // validar
        $request->validate([
            "nombre" => "required",
            "descripcion" => "required",
            "precio" => "required"
        ]);
        // modificar
        $plan = Plan::find($id);

        $plan->nombre = $request->nombre;
        $plan->descripcion = $request->descripcion;
        $plan->precio = $request->precio;
        $plan->update();
        // responder
        return response()->json([
            "status" => true,
            "plan" => "Plan modificado correctamente"
        ], 200);
    }
    /*
    public function obtener_plan_lista(Request $request)
    {


        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get('https://www.cloud.wispro.co/api/v1/plans');

        $datos = json_decode($response);
        // $datos2 = $datos->data;
        $datos2 = $datos;
        //dd($datos2);

        return response()->json($datos2, 200);
    }
    */

}