<?php

namespace App\Http\Controllers;

use App\Console\Commands\VolverHabilitarCatv;
use App\Events\RegisterPagosNetEvent;
use App\Helpers\Helpers;
use App\Models\CodigoRecaudacion;
use App\Models\ErrorSintesi;
use App\Models\PagoDetalle;
use App\Models\PagoSintesi;
use App\Models\Sintesi;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use App\Jobs\CargarDataSintesi;
use App\Models\Clienteswispro;
use App\Models\ListaNegra;
use App\Models\Planfull;
use App\Models\Smart;
use App\Models\Wisprocron;
use Carbon\Carbon;
use DateTime;
use DateTimeZone;
use Illuminate\Console\Scheduling\Schedule as SchedulingSchedule;
use Illuminate\Support\Facades\Artisan;
// use Illuminate\Support\Facades\Schedule;
// use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Support\Facades\Schedule;
use Illuminate\Support\Facades\Schema;
use Illuminate\Foundation\Inspiring;

class SintesiController extends Controller
{
    //
    public function cargar_datos_info($qrId, Request $request)
    {

        $categoriaProducto = 1;
        $codigoComprador = '200044';
        $codigoRecaudacion = 8;
        $correoElectronico = 'antonio@gmail.com';
        $descripcionRecaudacion = 'Servicio Internet mes de octubre';

        $documentoIdentidadComprador = '1234569';

        $fecha = 20231019;
        $fechaVencimiento = 0;
        $hora = 000340;
        $horaVencimiento = 0;
        $moneda = 'BS';
        $nombreComprador = 'Antonio pruebas';
        $descripcion = 'Servicio Internet mes de octubre';
        $montoCreditoFiscal = 100.0;
        $montoPago = 100.0;
        $nitFactura = '1234569';
        $nombreFactura = 'Antonio pruebas';
        $numeroPago = 1;
        $precedenciaCobro = 'N';
        $transaccion = 'A';

        /*
$cdr = base64_decode($cdr);
file_put_contents($carpetacdr."R-".$nombrezip, $cdr);
$zip = new ZipArchive;
if($zip->open($carpetacdr."R-".$nombrezip)===true){
$zip->extractTo($carpetacdr.'R-'.$nombrexml);
$zip->close();
}
//LEEMOS EL CDR
$docCDR = new DOMDocument();
$cdrContent = file_get_contents($carpetacdr.'R-'.$nombrexml.'/'.'R-'.$nombrexml.'.XML');
$docCDR->loadXML($cdrContent);

$responseCode = $docCDR->getElementsByTagName("ResponseCode")->item(0)->nodeValue;

if($responseCode==0){
echo "FACTURA APROBADA";
}else{
echo "FACTURA RECHAZADA CON CODIGO DE ERROR:".$responseCode;
}

echo "<br />";
echo $docCDR->getElementsByTagName("Description")->item(0)->nodeValue;

}else{
$codigo = $doc->getElementsByTagName("faultcode")->item(0)->nodeValue;
$mensaje = $doc->getElementsByTagName("faultstring")->item(0)->nodeValue;
echo "error ".$codigo.": ".$mensaje;
}
return $doc;
 */
    }

    public function lista(Request $request)
    {
        // $this->authorize("viewAny_role");
        /*
        if (isset($request->q)) {
            $buscar = $request->q;
            $sintesis = Sintesi::where("nombreComprador", "like", "%$buscar%")
                ->orWhere("codigoRecaudacion", "like", "%$buscar%")
                ->orWhere("documentoIdentidadComprador", "like", "%$buscar%")
                ->orWhere("codigoComprador", "like", "%$buscar%")
                ->get();
        } else {
            $sintesis = Sintesi::all();
        }´
        */
        $limit = isset($request->limit) ? $request->limit : 100;
        $buscar = $request->q ? $request->q : '';
        if (isset($buscar)) {
            // $buscar = $request->q;
            $sintesis = Sintesi::where('nombreComprador', 'like', "%$buscar%")
                ->orWhere('codigoRecaudacion', 'like', "%$buscar%")
                ->orWhere('documentoIdentidadComprador', 'like', "%$buscar%")
                ->orWhere('codigoComprador', 'like', "%$buscar%")
                ->paginate($limit);
        } else {
            $sintesis = Sintesi::orderBy('id', 'desc')->paginate($limit);
            // $productos = Producto::orderBy('id', 'desc')->with('categoria')->paginate($limit);
        }
        return response()->json([
            "success" => true,
            "data" => $sintesis,
        ], 200);
    }
    public function listaErrorSintesis(Request $request)
    {
        // $this->authorize("viewAny_role");

        if (isset($request->q)) {
            $buscar = $request->q;
            $sintesis = ErrorSintesi::where("customId", "like", "%$buscar%")
                ->orWhere("nombre", "like", "%$buscar%")
                ->orWhere("ci", "like", "%$buscar%")
                ->orWhere("monto", "like", "%$buscar%")
                ->get();
        } else {
            $sintesis = ErrorSintesi::all();
        }

        return response()->json([
            "success" => true,
            "data" => $sintesis,
        ], 200);
    }
    public function listapagos()
    {
        // $this->authorize("viewAny_role");

        //$roles = Role::get();
        $pago_sintesis = PagoSintesi::all();

        return response()->json([
            "success" => true,
            "data" => $pago_sintesis,
        ], 200);
    }
    public function lista_clientes_pagados(Request $request)
    {
        // $this->authorize("viewAny_role");

        if (isset($request->q)) {
            $buscar = $request->q;
            $pago_detalle = PagoDetalle::where("nombreComprador", "like", "%$buscar%")
                ->orWhere("codigoRecaudacion", "like", "%$buscar%")
                ->orWhere("documentoIdentidadComprador", "like", "%$buscar%")
                ->orWhere("codigoComprador", "like", "%$buscar%")
                ->get();
        } else {
            $pago_detalle = PagoDetalle::all();
        }
        return response()->json([
            "success" => true,
            "data" => $pago_detalle,
        ], 200);
    }
    public function buscar_pago_detalle(Request $request)
    {
        // $this->authorize("viewAny_role");
        // /api/producto?page=1&limit=5&q=camisa&orderby=nombre
        $buscar = isset($request->q) ? $request->q : '';
        if ($buscar) {
            $productos = PagoDetalle::where("nombreComprador", "like", "%$buscar%")
                ->orWhere("codigoRecaudacion", "like", "%$buscar%")
                ->orWhere("documentoIdentidadComprador", "like", "%$buscar%")
                ->orWhere("codigoComprador", "like", "%$buscar%")
                ->all();
        } else {
            $productos = [];
        }
        return response()->json([
            "success" => true,
            "data" => $productos,
        ], 200);
    }
    public function cargar_datos($id, Request $request)
    {
        ini_set('max_execution_time', 36000);
        Log::channel('sintesis')->info("Envio a Sintesis " . now());

        $responseTodosLosClientesWispro = Helpers::records_page($id, 20);

        $dataClientes = $responseTodosLosClientesWispro['data'];
        //return $dataClientes;
        Log::channel('sintesis')->info('Cantidad de clientes::>' . count($dataClientes));

        foreach ($dataClientes as $cliente) {
            $obtenerPrecio = Helpers::obtenerPrecioDelContratoXClientId($cliente['id']); //probar

            $correoElectronico = $cliente['email'] == null ? '' : $cliente['email'];
            $documentoIdentidadComprador = $cliente['national_identification_number'];
            $nombreComprador = $cliente['name'];
            $codigoComprador = $cliente['custom_id'];
            $montoCreditoFiscal = 0;
            $montoPago = $obtenerPrecio;
            $nitFactura = $cliente['national_identification_number'];
            $nombreFactura = $cliente['name'];
            $codigoRecaudacion = $codigoComprador; //$codigoRecaudacion2;

            // $cont++;
            //guardar
            $registroAlta = Helpers::registraAlta(
                $id,
                $correoElectronico,
                $documentoIdentidadComprador,
                $nombreComprador,
                $codigoComprador,
                $montoCreditoFiscal,
                $montoPago,
                $nitFactura,
                $nombreFactura,
                $codigoRecaudacion
            );
            // $codigoRecaudacion2++;
            //return $registroAlta;
            if ($registroAlta['codigoError'] == 0) {
                $idTransaccion = $registroAlta['idTransaccion'];
                $registroItem = Helpers::registraItem($idTransaccion, $montoPago);
                $new_sintesis = Sintesi::find($registroAlta['id']);
                if ($registroItem['codigoError'] == 0) {

                    Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador);

                    $new_sintesis->idTransaccion = $idTransaccion;
                    $new_sintesis->codigoError = $registroAlta['codigoError'];
                    $new_sintesis->descripcionError = $registroAlta['descripcionError'];
                    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];
                    $new_sintesis->update();
                } else {
                    $message = 'Error al registrar el item';
                    Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador);
                    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];

                    $new_sintesis->update();
                }
            } else {
                // todo Guardar el error en la BD
                Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador);
                $error_sintesis = new ErrorSintesi();
                $error_sintesis->customId = $codigoComprador;
                $error_sintesis->nombre = $nombreComprador;
                $error_sintesis->ci = $documentoIdentidadComprador;
                $error_sintesis->monto = $montoPago;
                $error_sintesis->save();
                $message = 'Error al cargar info en sintesis';
                $update_sintesis = Sintesi::find($registroAlta['id']);
                $update_sintesis->codigoError = $registroAlta['codigoError'];
                $update_sintesis->descripcionError = $registroAlta['descripcionError'];
                $update_sintesis->update();
            }
        }
        //$rec->cod_recaudacion = $codigoRecaudacion2;
        //$rec->update();
        Log::channel('sintesis')->info('Se enviaron :::' . count($dataClientes) . ' :::::::::::>');

        return response()->json([
            'id' => $id,
            'codError' => 0,
            'descripcion' => "Registros enviados a Sintesis Correctamente",
        ], 201, [], JSON_UNESCAPED_UNICODE);
    }

    public function obtenerPlanNuevo($customId)
    {
        $client_uuid = Helpers::obtenerClienteUUId($customId);
        $estado_contrato = Helpers::obtenerEstadoDelContratosXuuid($client_uuid);
        return $estado_contrato['precio'];
    }
    public function baja_item_sintesis($id, Request $request)
    {

        $todos_los_datos = $request->all();
        Log::channel('sintesis')->info("Envio de Baja a Sintesis " . now());

        $correoElectronico = $todos_los_datos['correoElectronico'] == null ? '' : $todos_los_datos['correoElectronico'];
        $documentoIdentidadComprador = $todos_los_datos['documentoIdentidadComprador'];
        $nombreComprador = $todos_los_datos['nombreComprador'];
        $codigoComprador = $todos_los_datos['codigoComprador'];
        $montoCreditoFiscal = 0;
        $montoPago = $todos_los_datos['montoPago'];
        $nitFactura = $todos_los_datos['nitFactura'];
        $nombreFactura = $todos_los_datos['nombreFactura'];
        $codigoRecaudacion = $todos_los_datos['codigoRecaudacion'];

        /*
return [
$correoElectronico,
$documentoIdentidadComprador,
$nombreComprador,
$codigoComprador,
$montoCreditoFiscal,
$montoPago,
$nitFactura,
$nombreFactura,
$codigoRecaudacion,
$todos_los_datos['precioActualWispro']
];
 */

        //guardar

        $registroBaja = Helpers::registraBaja(
            $correoElectronico,
            $documentoIdentidadComprador,
            $nombreComprador,
            $codigoComprador,
            $montoCreditoFiscal,
            $montoPago,
            $nitFactura,
            $nombreFactura,
            $codigoRecaudacion
        );

        if ($registroBaja['codigoError'] == 0) {

            $registroAlta = Helpers::registroUpdate(

                $correoElectronico,
                $documentoIdentidadComprador,
                $nombreComprador,
                $codigoComprador,
                $montoCreditoFiscal,
                $todos_los_datos['precioActualWispro'],
                $nitFactura,
                $nombreFactura,
                $codigoRecaudacion
            );

            if ($registroAlta['codigoError'] == 0) {

                $idTransaccion = $registroAlta['idTransaccion'];
                $registroItem = Helpers::registraItem($idTransaccion, $todos_los_datos['precioActualWispro']);
                // $new_sintesis = Sintesi::where('codigoRecaudacion', $codigoRecaudacion)->first();

                if ($registroItem['codigoError'] == 0) {

                    Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador . ':: codRe:' .
                        $codigoRecaudacion);

                    // $new_sintesis->fechaVencimiento = $fechaVencimiento;
                    // $new_sintesis->horaVencimiento = $horaVencimiento;

                    // $new_sintesis->numeroPago = $numeroPago;

                    $new_sintesis = Sintesi::find($id);
                    $new_sintesis->idTransaccion = $registroAlta['idTransaccion'];
                    $new_sintesis->montoPago = $todos_los_datos['precioActualWispro'];
                    $new_sintesis->codigoError = $registroAlta['codigoError'];
                    $new_sintesis->descripcionError = $registroAlta['descripcionError'];
                    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];

                    $new_sintesis->update();
                    return response()->json([
                        'success' => true,
                        'status' => 201,
                        'mensaje' => $registroAlta['descripcionError'],
                    ], 201);
                    // return [
                    // $registroAlta['codigoError'],
                    // $registroAlta['descripcionError'],
                    // $registroAlta['idTransaccion'],
                    // $registroItem['codigoError'],
                    // $registroItem['descripcionError'],
                    // ];
                } else {
                    $message = 'Error al registrar el item';
                    Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador . ':: codRe:' .
                        $codigoRecaudacion);
                    $new_sintesis = Sintesi::find($id);
                    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];
                    $new_sintesis->update();
                    $error_sintesis = new ErrorSintesi();
                    $error_sintesis->customId = $codigoComprador;
                    $error_sintesis->nombre = $nombreComprador;
                    $error_sintesis->ci = $documentoIdentidadComprador;
                    $error_sintesis->monto = $montoPago;
                    $error_sintesis->save();
                    return response()->json([
                        'success' => false,
                        'status' => false,
                        'mensaje' => $registroItem['descripcionError'],
                    ], 403);
                    // return [
                    // $message,
                    // $registroItem['codigoError'],
                    // $registroItem['descripcionError'],
                    // ];
                }
            } else {
                // todo Guardar el error en la BD
                $error_sintesis = new ErrorSintesi();
                $error_sintesis->customId = $codigoComprador;
                $error_sintesis->nombre = $nombreComprador;
                $error_sintesis->ci = $documentoIdentidadComprador;
                $error_sintesis->monto = $montoPago;
                $error_sintesis->save();
                $message = 'Error al cargar info en sintesis';
                $update_sintesis = Sintesi::find($codigoRecaudacion);
                $update_sintesis->codigoError = $registroAlta['codigoError'];
                $update_sintesis->descripcionError = $registroAlta['descripcionError'];
                $update_sintesis->update();
                /*
return [
$message,
$registroAlta['codigoError'],
$registroAlta['descripcionError'],
];
 */
            }
        } else {
            $error_sintesis = new ErrorSintesi();
            $error_sintesis->customId = $codigoComprador;
            $error_sintesis->nombre = $nombreComprador;
            $error_sintesis->ci = $documentoIdentidadComprador;
            $error_sintesis->monto = $montoPago;
            $error_sintesis->save();
            return response()->json([
                'success' => false,
                'mensaje' => $registroBaja['descripcionError'],
            ], 403);
        }
    }
    public function delete_datos()
    {

        //*****

        /*
$sintesiCount = Sintesi::all()->count();
$sintesiData = Sintesi::all();
DeleteData::dispatch($sintesiData);
 */
        //******

        //*************************************************************************
        $sintesiCount = Sintesi::all()->count();
        $sintesiData = Sintesi::all();

        $sintesiData3 = [

            [
                "correoElectronico" => "",
                "documentoIdentidadComprador" => "5652951",
                "nombreComprador" => "Pablo Llacza Anagua",
                "codigoComprador" => "210012",
                "montoCreditoFiscal" => 0,
                "montoPago" => 100,
                "nitFactura" => "5652951",
                "nombreFactura" => "Pablo Llacza Anagua",
                "codigoRecaudacion" => "210012202402",

            ],
            [
                "correoElectronico" => "imprentagrafic.printer@gmail.com",
                "documentoIdentidadComprador" => "4852429",
                "nombreComprador" => "German Pillco",
                "codigoComprador" => "210088",
                "montoCreditoFiscal" => 0,
                "montoPago" => 100,
                "nitFactura" => "4852429",
                "nombreFactura" => "German Pillco",
                "codigoRecaudacion" => "210088202402",

            ],

        ];
        $contadorOK = 0;
        $contadorError = 0;
        foreach ($sintesiData as $data) {
            $registroBaja = Helpers::registraBaja(
                $data['correoElectronico'],
                $data['documentoIdentidadComprador'],
                $data['nombreComprador'],
                $data['codigoComprador'],
                $data['montoCreditoFiscal'],
                $data['montoPago'],
                $data['nitFactura'],
                $data['nombreFactura'],
                $data['codigoRecaudacion']
            );
            // echo $registroBaja['codigoError']."<br>";
            // echo $registroBaja['descripcionError'].'<br>';
            // echo $registroBaja['idTransaccion'].'<br>';
            if ($registroBaja['codigoError'] == 0) {
                $contadorOK++;
                Log::info($contadorOK . "- codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] . "
descripcion:
" . $registroBaja['descripcionError']);
                // \Log::info();
                // \Log::info($registroBaja['idTransaccion']);
            } else if ($registroBaja['codigoError'] == 1) {
                $contadorError++;
                Log::info($contadorError . "- codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] .
                    " descripcion:
" . $registroBaja['descripcionError']);
                // \Log::info($registroBaja['descripcionError']);
            } else {
                $contadorError++;
                Log::info($contadorError . "- error");
            }
        }

        //*************************************************************************

        /* $sintesiData = [

[
"correoElectronico" => "",
"documentoIdentidadComprador" => "5652951",
"nombreComprador" => "Pablo Llacza Anagua",
"codigoComprador" => "210012",
"montoCreditoFiscal" => 0,
"montoPago" => 100,
"nitFactura" => "5652951",
"nombreFactura" => "Pablo Llacza Anagua",
"codigoRecaudacion" => "210012202402",

],
[
"correoElectronico" => "imprentagrafic.printer@gmail.com",
"documentoIdentidadComprador" => "4852429",
"nombreComprador" => "German Pillco",
"codigoComprador" => "210088",
"montoCreditoFiscal" => 0,
"montoPago" => 100,
"nitFactura" => "4852429",
"nombreFactura" => "German Pillco",
"codigoRecaudacion" => "210088202402",

]

];

foreach ($sintesiData as $data) {
$registroBaja = Helpers::registraBaja(
$data['correoElectronico'],
$data['documentoIdentidadComprador'],
$data['nombreComprador'],
$data['codigoComprador'],
$data['montoCreditoFiscal'],
$data['montoPago'],
$data['nitFactura'],
$data['nombreFactura'],
$data['codigoRecaudacion'],
);
// echo $registroBaja['codigoError']."<br>";
// echo $registroBaja['descripcionError'].'<br>';
// echo $registroBaja['idTransaccion'].'<br>';
if ($registroBaja['codigoError'] == 0) {
\Log::info("codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] . " descripcion:
" . $registroBaja['descripcionError']);
// \Log::info();
// \Log::info($registroBaja['idTransaccion']);
} else if ($registroBaja['codigoError'] == 1) {
\Log::info("codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] . " descripcion:
" . $registroBaja['descripcionError']);
// \Log::info($registroBaja['descripcionError']);
} else {
\Log::info("error");
}
}
 */
        return response()->json([
            'success' => true,
            'count' => $sintesiCount,
            'data' => $sintesiData,
        ], 200);
    }
    public function crear_notificacion_sintesis(Request $request)
    {
        $todos_los_datos = $request->all();

        // $credenciales = $request->validate([
        // "usuario" => "required",
        // "clave" => "required",
        // "codigoEmpresa" => "required"
        // ]);
        if (!Auth::attempt(['name' => $todos_los_datos['usuario'], 'password' => $todos_los_datos['clave'], 'cuenta' =>
        $todos_los_datos['codigoEmpresa']])) {
            return response()->json([
                'codError' => 1,
                'descripcion' => "Credenciales incorrectas",
            ], 401, [], JSON_UNESCAPED_UNICODE);
            // ], 401);
        }

        //Verificamos si el codigo de recaudacion existe en la BD

        $codigoRecaudacion = Sintesi::where("codigoRecaudacion", $todos_los_datos['codigoRecaudacion'])->count();
        //Verificamos el codigo de recaudacion
        if ($codigoRecaudacion == 0) {
            return response()->json([
                'codError' => 1,
                'descripcion' => "Error no existe codigo de recaudacion",
            ], 422, [], JSON_UNESCAPED_UNICODE);
            // ], 401);
        }

        // Registramos en la BD el Pago
        DB::beginTransaction();
        try {

            $new_pago = new PagoSintesi();
            $new_pago->codigoRecaudacion = $todos_los_datos['codigoRecaudacion'];
            $new_pago->codigoProducto = $todos_los_datos['codigoProducto'];
            $new_pago->numeroPago = $todos_los_datos['numeroPago'];
            $new_pago->fecha = $todos_los_datos['fecha'];
            $new_pago->secuencial = $todos_los_datos['secuencial'];
            $new_pago->hora = $todos_los_datos['hora'];
            $new_pago->origenTransaccion = $todos_los_datos['origenTransaccion'];
            $new_pago->pais = $todos_los_datos['pais'];
            $new_pago->departamento = $todos_los_datos['departamento'];
            $new_pago->ciudad = $todos_los_datos['ciudad'];
            $new_pago->entidad = $todos_los_datos['entidad'];
            $new_pago->agencia = $todos_los_datos['agencia'];
            $new_pago->operador = $todos_los_datos['operador'];
            $new_pago->monto = $todos_los_datos['monto'];
            $new_pago->loteDosificacion = $todos_los_datos['loteDosificacion'];
            $new_pago->nroRentaRecibo = $todos_los_datos['nroRentaRecibo'];
            $new_pago->montoCreditoFiscal = $todos_los_datos['montoCreditoFiscal'];
            $new_pago->codigoAutorizacion = $todos_los_datos['codigoAutorizacion'];
            $new_pago->codigoControl = $todos_los_datos['codigoControl'];
            $new_pago->nitFacturar = $todos_los_datos['nitFacturar'];
            $new_pago->nombreFacturar = $todos_los_datos['nombreFacturar'];
            $new_pago->transaccion = $todos_los_datos['transaccion'];
            $new_pago->save();

            DB::commit();

            RegisterPagosNetEvent::dispatch($new_pago);
            return response()->json([
                'codError' => 0,
                'descripcion' => "Registro exitoso",

            ], 201, [], JSON_UNESCAPED_UNICODE);
        } catch (\Exception $e) {
            Log::channel('errorpagoSintesis')->info("---------------------------" . now() . "---------------------------");
            Log::channel('errorpagoSintesis')->info("error: " . $e);
            // $error_sintesis = new ErrorSintesi();
            // $error_sintesis->customId = $e;
            // // $error_sintesis->nombre = $nombreComprador;
            // // $error_sintesis->ci = $documentoIdentidadComprador;
            // $error_sintesis->monto = $todos_los_datos['monto'];
            // $error_sintesis->codigoRecaudacion = $todos_los_datos['codigoRecaudacion'];
            // $error_sintesis->save();

            DB::rollBack();

            return response()->json([
                'codError' => 1,
                'descripcion' => "Error al registrar el pago",

            ], 422, [], JSON_UNESCAPED_UNICODE);
        }
    }

    public function habilitarEquipos(Request $request)
    {
        ini_set('max_execution_time', 360000);
        try {
            $conta = 1;
            $conta2 = 0;
            $cadena = "";
            $cadenaArray = [];
            // deshabilitar_cattv
            //  $res = Helpers::deshabilitar_multiple_cattv("200020");

            // $res['status'];
            //  return $res;
            $lista = Wisprocron::where("estado", true)->get();
            // return $lista[0]->custom_id;
            for ($i = 0; $i < count($lista); $i++) {
                //$res = Helpers::habilitar_cattv($plan2[$i]);
                //  $conta++;
                // echo $plan2[$i];

                if ($conta > 10) {
                    array_push($cadenaArray, $cadena);
                    $cadena = "";
                    $conta = 1;
                    $cadena = $cadena . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                } else {
                    $conta == 1 ? $cadena = $cadena . $lista[$i]->custom_id : $cadena = $cadena . ',' . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                }
            }
            array_push($cadenaArray, $cadena);

            for ($i = 0; $i < count($cadenaArray); $i++) {
                # code...

                $res = Helpers::habilitar_multiple_cattv($cadenaArray[$i]);

                if ($res['response_code'] === "success") {
                    Log::channel('habilitar138')->info($i . '.- Habilitado:' . $cadenaArray[$i]);
                } else {
                    Log::channel('habilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                    $error_habilitados = $cadenaArray[$i];
                }
                // sleep(2);
            }

            return response()->json([
                "conta2" => $conta2,
                "cadena" => $cadena,
                // "cantPlan" => count($custom_ids),
                "cant" => count($cadenaArray),

                "data" => $cadenaArray,
            ]);
        } catch (\Exception $e) {
            //throw $th;
            return $e;
        }
        $page = 1;
        $per_page = 20;
        $TodosClientesDeshabilitados = Helpers::obtenerTodosLosContratosDisabled(); //Total Contratos Disabled    
        // return $TodosClientesDeshabilitados[1];
        //  sleep(2);
        $TodosClientes = Helpers::obtenerTodosLosClientesWispro(); //Total Contratos Disabled    
        $custom_ids = [];
        // return  $TodosClientes[0]['client_id'];
        $switch = true;
        for ($i = 0; $i < count($TodosClientesDeshabilitados); $i++) {
            $j = 0;
            $switch = true;
            while ($switch) {
                // $TodosClientesDeshabilitados[$i] == $TodosClientes[$j]['client_id']
                // Log::channel('habilitar138')->error('Deshabilitado:' . $TodosClientesDeshabilitados[$i] . ' == ' . $TodosClientes[$j]['client_id']);
                if ($TodosClientesDeshabilitados[$i] == $TodosClientes[$j]['client_id']) {
                    $custom_ids[] = $TodosClientes[$j]['custom_id'];
                    $switch = false;
                }
                $j++;
            }
        }
        $custom_ids; // aqui esta todos los custom ids
        // Ahora ordenamos de 10 en 10 los customIds
        $conta = 1;
        $conta2 = 0;
        $cadena = "";
        $cadenaArray = [];
        for ($i = 0; $i < count($custom_ids); $i++) {
            //$res = Helpers::habilitar_cattv($plan2[$i]);
            //  $conta++;
            // echo $plan2[$i];

            if ($conta > 10) {
                array_push($cadenaArray, $cadena);
                $cadena = "";
                $conta = 1;
                $cadena = $cadena . $custom_ids[$i];
                $conta++;
                $conta2++;
            } else {
                $conta == 1 ? $cadena = $cadena . $custom_ids[$i] : $cadena = $cadena . ',' . $custom_ids[$i];
                $conta++;
                $conta2++;
            }
        }
        array_push($cadenaArray, $cadena); // aqui tenemos en 1 item 10 custom id

        $ii = 0;
        $error_habilitados = [];
        $error_deshabilitados = [];
        // habilitamos
        for ($i = 0; $i < count($cadenaArray); $i++) {
            # code...

            $res = Helpers::apagarOnus($cadenaArray[$i]);

            if ($res['response_code'] === "success") {
                Log::channel('apagarOnus')->info($i . '.- Equipo Apagado:' . $cadenaArray[$i]);
            } else {
                Log::channel('apagarOnus')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                $error_habilitados = $cadenaArray[$i];
            }
            sleep(2);
        }

        return response()->json([
            "conta2" => $conta2,
            "cadena" => $cadena,
            "cantPlan" => count($custom_ids),
            "cant" => count($cadenaArray),

            "data" => $cadenaArray,
        ]);
    }
    public function deshabilitarEquipos(Request $request)
    {
        ini_set('max_execution_time', 360000);
        try {
            $conta = 1;
            $conta2 = 0;
            $cadena = "";
            $cadenaArray = [];
            // deshabilitar_cattv
            //  $res = Helpers::deshabilitar_multiple_cattv("200020");

            // $res['status'];
            //  return $res;
            $lista = Wisprocron::where("estado", true)->get();
            // return $lista[0]->custom_id;
            for ($i = 0; $i < count($lista); $i++) {
                //$res = Helpers::habilitar_cattv($plan2[$i]);
                //  $conta++;
                // echo $plan2[$i];

                if ($conta > 10) {
                    array_push($cadenaArray, $cadena);
                    $cadena = "";
                    $conta = 1;
                    $cadena = $cadena . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                } else {
                    $conta == 1 ? $cadena = $cadena . $lista[$i]->custom_id : $cadena = $cadena . ',' . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                }
            }
            array_push($cadenaArray, $cadena);

            // deshabilitamos
            for ($i = 0; $i < count($cadenaArray); $i++) {
                $res = Helpers::deshabilitar_multiple_cattv($cadenaArray[$i]);

                if ($res['response_code'] === "success") {
                    Log::channel('deshabilitar138')->info($i . '.- Deshabilitado:' . $cadenaArray[$i]);
                } else {
                    Log::channel('deshabilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                    $error_deshabilitados = $cadenaArray[$i];
                }
                // sleep(2);
            }

            return response()->json([
                "conta2" => $conta2,
                "cadena" => $cadena,
                // "cantPlan" => count($custom_ids),
                "cant" => count($cadenaArray),

                "data" => $cadenaArray,
            ]);
        } catch (\Exception $e) {
            //throw $th;
            return $e;
        }
        $page = 1;
        $per_page = 20;
        $TodosClientesDeshabilitados = Helpers::obtenerTodosLosContratosDisabled(); //Total Contratos Disabled    
        // return $TodosClientesDeshabilitados[1];
        //  sleep(2);
        $TodosClientes = Helpers::obtenerTodosLosClientesWispro(); //Total Contratos Disabled    
        $custom_ids = [];
        // return  $TodosClientes[0]['client_id'];
        $switch = true;
        for ($i = 0; $i < count($TodosClientesDeshabilitados); $i++) {
            $j = 0;
            $switch = true;
            while ($switch) {
                // $TodosClientesDeshabilitados[$i] == $TodosClientes[$j]['client_id']
                // Log::channel('habilitar138')->error('Deshabilitado:' . $TodosClientesDeshabilitados[$i] . ' == ' . $TodosClientes[$j]['client_id']);
                if ($TodosClientesDeshabilitados[$i] == $TodosClientes[$j]['client_id']) {
                    $custom_ids[] = $TodosClientes[$j]['custom_id'];
                    $switch = false;
                }
                $j++;
            }
        }
        $custom_ids; // aqui esta todos los custom ids
        // Ahora ordenamos de 10 en 10 los customIds
        $conta = 1;
        $conta2 = 0;
        $cadena = "";
        $cadenaArray = [];
        for ($i = 0; $i < count($custom_ids); $i++) {
            //$res = Helpers::habilitar_cattv($plan2[$i]);
            //  $conta++;
            // echo $plan2[$i];

            if ($conta > 10) {
                array_push($cadenaArray, $cadena);
                $cadena = "";
                $conta = 1;
                $cadena = $cadena . $custom_ids[$i];
                $conta++;
                $conta2++;
            } else {
                $conta == 1 ? $cadena = $cadena . $custom_ids[$i] : $cadena = $cadena . ',' . $custom_ids[$i];
                $conta++;
                $conta2++;
            }
        }
        array_push($cadenaArray, $cadena); // aqui tenemos en 1 item 10 custom id

        $ii = 0;
        $error_habilitados = [];
        $error_deshabilitados = [];
        // habilitamos
        for ($i = 0; $i < count($cadenaArray); $i++) {
            # code...

            $res = Helpers::apagarOnus($cadenaArray[$i]);

            if ($res['response_code'] === "success") {
                Log::channel('apagarOnus')->info($i . '.- Equipo Apagado:' . $cadenaArray[$i]);
            } else {
                Log::channel('apagarOnus')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                $error_habilitados = $cadenaArray[$i];
            }
            sleep(2);
        }

        return response()->json([
            "conta2" => $conta2,
            "cadena" => $cadena,
            "cantPlan" => count($custom_ids),
            "cant" => count($cadenaArray),

            "data" => $cadenaArray,
        ]);
    }
    public function activar_desactivar(Request $request)
    {
        ini_set('max_execution_time', 360000);
        Log::channel('cronHabilitaDeshabilita')->info('Este log comenzo inicio a esta hora  ' . now());


        DB::beginTransaction();
        try {

            $smart = Smart::count();

            if ($smart > 0) {

                Smart::query()->delete();
                Wisprocron::query()->delete();
            }

            $listaEstadoOnus = Helpers::obtenerTodaListaOnusEstado();
            foreach ($listaEstadoOnus['onus'] as $onu) {
                $onus = new Smart();
                $onus->unique_external_id = $onu['unique_external_id'];
                $onus->onu_type_id = $onu['onu_type_id'];
                $onus->onu_type_name = $onu['onu_type_name'];
                $onus->wan_mode = $onu['wan_mode'];
                $onus->estado = true;
                $onus->save();
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de SmartOLT  ' . now());
            $countWis = Wisprocron::count();
            if ($countWis > 0) {
                // DB::table('wisprocrons')->truncate();
                Wisprocron::query()->delete();
            }

            $plan_id = "";
            $precio = 138;

            $todosPlanes = Helpers::obtenerTodosLosPlanesWispro();
            //  return $todosPlanes['data'];
            $countPlanFull = Planfull::count();
            if ($countPlanFull > 0) {
                // DB::table('planfulls')->truncate();
                Planfull::query()->delete();
            }
            foreach ($todosPlanes['data'] as $plan) {
                $planfu = new Planfull();
                $planfu->id_plan = $plan['id'];
                $planfu->name = $plan['name'];
                $planfu->price = $plan['price'];
                $planfu->save();
                if ($plan['price'] == $precio) {
                    $plan_id = $plan['id'];
                }
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Planfull   ' . now());
            //Obtenemos todos los contratos de wispro con el plan 138 y todos los deshabilitados
            $listaTodosContratos = Helpers::obtenerTodosLosContratosWisproPlanODeshabilitadoBBDD($plan_id); //Guarda todo en BBDD


            $countClient = Clienteswispro::count();
            if ($countClient > 0) {
                // DB::table('clienteswispros')->truncate();
                Clienteswispro::query()->delete();
            }
            // if ($countClient == 0) {

            // ahora comparamos los solo los contratos y los actualizamos con el customID y name en la tabla Wisprocron
            $todosContratos = Wisprocron::select("plan_id", "client_id")->get();
            //return count($todosContratos);
            // ahora obtenemos todos los clientes
            $response = Helpers::obtenerTodosLosClientesWisproBBDD(); //Guarda todos los clientes en BBDD
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Clienteswispro   ' . now());
            $todosLosClientesWispro = Clienteswispro::select("client_id", "custom_id", "name")->get();
            $con3 = 0;
            $con60 = 0;

            foreach ($todosContratos as $contrato) {
                # code...
                $con3++;
                foreach ($todosLosClientesWispro as $client) {
                    # code...
                    if ($contrato->client_id == $client->client_id) {
                        $con60++;
                        $cli = Wisprocron::where("client_id", $client->client_id)->first();
                        $cli->custom_id = $client->custom_id;
                        $cli->name = $client->name;
                        $cli->save();
                        // Log::channel('apagarOnus')->error($con60 . '.- clienteID:' . $client->client_id . ' customId:' . $client->custom_id . ' name: ' . $client->name);

                        break;
                    }
                }
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Wisprocron cons custom_id y nombre    '  . now());
            // Obtenemos de la BD

            $modelo1 = "GP4442V9.0";
            $modelo2 = "UT-GP4442V9.0";
            $modelo3 = "YSD-101";
            $modelo4 = "XPON2GFRFW";
            $onusDeatils = Smart::where("onu_type_name", $modelo1)
                ->orWhere("onu_type_name", $modelo2)
                ->orWhere("onu_type_name", $modelo3)
                ->orWhere("onu_type_name", $modelo4)
                ->get();
            // ahora comparamos
            $wisproCron = Wisprocron::all();
            //   return $onusDeatils;
            $ar = [];
            $iii = 0;
            foreach ($wisproCron as $wispro) {
                # code...onusDeatils
                foreach ($onusDeatils as $onu) {
                    # code...
                    if ($wispro->custom_id == $onu->unique_external_id) {
                        $ar[] = $onu->unique_external_id;
                        $price2 = Planfull::select("price")->where("id_plan", $wispro->plan_id)->first();
                        $cli = Wisprocron::where("custom_id", $onu->unique_external_id)->first();
                        $cli->estado = true;
                        $cli->precio = $price2->price;
                        $iii++;
                        // Log::channel('cronHabilitaDeshabilita')->info('id::> ' . $iii . '  Cliente::>' . $wispro->custom_id . '  precio::>' . $cli->precio);
                        $cli->update();
                        break;
                    }
                }
            }

            Log::channel('cronHabilitaDeshabilita')->info('Termino de carga la informacion para el cron :: ' . now());
            $clientesCron = Wisprocron::where("estado", true)->get();
            Log::channel('cronHabilitaDeshabilita')->info('Cantidad de clientes en el cron :: ' . count($clientesCron));


            DB::commit();


            return response()->json([

                "total" => count($ar),
                "totalcli34" => count($clientesCron),
                "data" => $clientesCron
            ]);
        } catch (\Exception $e) {
            DB::rollback();

            Log::channel('cronHabilitaDeshabilita')->error('Hubo un error en la carga de informacion para el cron :: ' . now());
            Log::channel('cronHabilitaDeshabilita')->error($e);

            return response()->json([
                "success" => false,

                "message" => "Error. " . $e
            ], 422);
        }

        // } else {
        //     $clientesCron = Wisprocron::where("estado", true)->get();
        //     return response()->json([
        //         "totalcli34" => count($clientesCron),
        //         "data" => $clientesCron
        //     ]);
        // }







        return response()->json([
            "total" => count($onusDeatils),
            "todosContratos" => json_decode($onusDeatils),
            // "clientes" => $todosLosClientesWispro
        ]);
        // Obtenemos la lista de tipos de Onu
        /*
        $listaOnus = Helpers::obtenerListaTiposOnu();
        $conta = 0;
        $listaOnusIds = []; //example ["60","66","59","68"]
        $res = []; // example [{"id": "60","name": "GP4442V9.0"},{"id": "66","name": "UT-GP4442V9.0"},{"id": "59","name": "XPON2GFRFW"},{"id": "68","name": "YSD-101"}]
        foreach ($listaOnus['response'] as $onu) {
            # code...
            $conta++;
            switch ($onu['name']) {
                case "UT-GP4442V9.0":

                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "GP4442V9.0":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "YSD-101":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "XPON2GFRFW":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
            }
        }
        return $res;
        // count($listaOnus['response']);
        return $listaOnus['response'];
*/

        return response()->json([
            // "conta2" => $conta2,
            // "cadena" => $cadena,
            // "cantPlan" => count($custom_ids),
            // "cant" => count($cadenaArray),

            "data" => $listaOnus,
        ]);
    }
    public function lista_deshabilitados(Request $request)
    {
        ini_set('max_execution_time', 360000);


        $clientesCron = Wisprocron::count();
        if ($clientesCron > 0) {
            // $clientesCron = Wisprocron::where("estado", true)->get();


            $limit = isset($request->limit) ? $request->limit : 200;
            $buscar = $request->q ? $request->q : '';
            if (isset($buscar)) {


                $clientesCron = Wisprocron::where('estado', '=', true)
                    ->where(function ($query) use ($buscar) {
                        $query->where('custom_id', 'like', "%$buscar%")
                            ->orWhere('custom_id', 'like', "%$buscar%")
                            ->orWhere('name', 'like', "%$buscar%")
                            ->orWhere('precio', 'like', "%$buscar%")
                            ->orWhere('state', 'like', "%$buscar%");
                    })->paginate($limit);
            } else {
                $clientesCron = Wisprocron::where("estado", true)->get();
            }


            return response()->json([
                "success" => true,
                "status" => 422,
                "totalClientes" => count($clientesCron),
                "data" => $clientesCron
            ], 200);
        } else {
            return response()->json([
                "success" => true,
                "status" => 422,
                "mensaje" => "Error al obtener la lista de Deshabilitados",
            ], 422);
        }
    }
    public function activarWispro(Request $request)
    {
        ini_set('max_execution_time', 360000);
        $todo = $request->all();

        try {
            //code...
            // Habilitar contrato  
            //   $resultWispro = Helpers::habilitarContrato($todo['contrato_id']);
            // Habilitar Smart
            $resultSmart = Helpers::habilitar_cattv($todo['custom_id']);
            // $result = Helpers::rebootSmart($todo['custom_id']);

            //         deshabilitar_cattv
            //         
            // deshabilitarContrato
            // eliminar BD Wisprocron
            $resultWiscron = Wisprocron::find($todo['id']);
            $resultWiscron->delete();
            //if ($todo['precio'] > 138) {
            //    $resultWiscron = Wisprocron::find($todo['id']);
            //  $resultWiscron->state = 'enabled';
            //    $resultWiscron->estado = false;
            //   $resultWiscron->save();
            //}
            return response()->json([
                "success" => true,
                "status" => 200,
                "mensaje" => "EL cliente " . $todo['name'] . ' fue habilitado exitosamente.',
            ], 200);
        } catch (\Exception $e) {
            return response()->json([
                "success" => false,
                "status" => 422,
                "mensaje" => $e,
            ], 422);
        }
    }

    public function activar_smart_178(Request $request)
    {
        ini_set('max_execution_time', 360000);



        //   DB::beginTransaction();
        try {






            $plan_id = "4280a110-8a3b-4493-8784-c45355b9d5b0";
            $precio = 178;




            //Obtenemos todos los contratos de wispro con el plan 138 y todos los deshabilitados
            //  ejecutar solo cunado esta vacio
            // $listaTodosContratos = Helpers::guardarTodosLosContratosWisproPlan178BBDD($plan_id); //Guarda todo en BBDD los que estan en ese plan
            // return  $listaTodosContratos;
            // $countClient = Wisprocron::count();
            // $contratos178 = Wisprocron::all();



            // if ($countClient == 0) {

            // ahora comparamos los solo los contratos y los actualizamos con el customID y name en la tabla Wisprocron
            $todosContratos = Wisprocron::select("client_id")->get();

            $todosLosClientesWispro = Clienteswispro::select("client_id", "custom_id")->get();


            $con3 = 0;
            $con60 = 0;

            foreach ($todosContratos as $contrato) {
                # code...
                $con3++;
                foreach ($todosLosClientesWispro as $client) {
                    # code...
                    if ($contrato->client_id == $client->client_id) {
                        $con60++;
                        $cli = Wisprocron::where("client_id", $client->client_id)->first();
                        $cli->custom_id = $client->custom_id;
                        $cli->save();
                        // Log::channel('apagarOnus')->error($con60 . '.- clienteID:' . $client->client_id . ' customId:' . $client->custom_id . ' name: ' . $client->name);

                        break;
                    }
                }
            }
            $conta = 1;
            $conta2 = 0;
            $cadena = "";
            $cadenaArray = [];
            $wisproCron = Wisprocron::all();
            $lista = Wisprocron::select('custom_id')->get();
            // return $lista;
            // return $lista[0]->custom_id;
            for ($i = 0; $i < count($lista); $i++) {
                //$res = Helpers::habilitar_cattv($plan2[$i]);
                //  $conta++;
                // echo $plan2[$i];

                if ($conta > 10) {
                    array_push($cadenaArray, $cadena);
                    $cadena = "";
                    $conta = 1;
                    $cadena = $cadena . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                } else {
                    $conta == 1 ? $cadena = $cadena . $lista[$i]->custom_id : $cadena = $cadena . ',' . $lista[$i]->custom_id;
                    $conta++;
                    $conta2++;
                }
            }
            array_push($cadenaArray, $cadena);
            // habilitamos a todos
            for ($i = 0; $i < count($cadenaArray); $i++) {
                # code...

                $res = Helpers::habilitar_multiple_cattv($cadenaArray[$i]);
                Log::channel('habilitar138')->info($i . '.- Habilitado:' . $res);

                // if ($res['status'] == true) {
                // } else {
                //     Log::channel('habilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                //     //  $error_habilitados = $cadenaArray[$i];
                // }
            }

            return response()->json([

                // "total" => count($ar),
                "totalcli34" => count($cadenaArray),
                "data" => $cadenaArray
            ]);
        } catch (\Exception $e) {
            // DB::rollback();



            return response()->json([
                "success" => false,

                "message" => "Error. " . $e
            ], 422);
        }

        // } else {
        //     $clientesCron = Wisprocron::where("estado", true)->get();
        //     return response()->json([
        //         "totalcli34" => count($clientesCron),
        //         "data" => $clientesCron
        //     ]);
        // }







        return response()->json([
            "total" => count($onusDeatils),
            "todosContratos" => json_decode($onusDeatils),
            // "clientes" => $todosLosClientesWispro
        ]);
        // Obtenemos la lista de tipos de Onu
        /*
        $listaOnus = Helpers::obtenerListaTiposOnu();
        $conta = 0;
        $listaOnusIds = []; //example ["60","66","59","68"]
        $res = []; // example [{"id": "60","name": "GP4442V9.0"},{"id": "66","name": "UT-GP4442V9.0"},{"id": "59","name": "XPON2GFRFW"},{"id": "68","name": "YSD-101"}]
        foreach ($listaOnus['response'] as $onu) {
            # code...
            $conta++;
            switch ($onu['name']) {
                case "UT-GP4442V9.0":

                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "GP4442V9.0":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "YSD-101":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
                case "XPON2GFRFW":
                    $res[] = ["id" => $onu['id'], "name" => $onu['name']];
                    $listaOnusIds[] = $onu['id'];
                    break;
            }
        }
        return $res;
        // count($listaOnus['response']);
        return $listaOnus['response'];
*/

        return response()->json([
            // "conta2" => $conta2,
            // "cadena" => $cadena,
            // "cantPlan" => count($custom_ids),
            // "cant" => count($cadenaArray),

            "data" => $listaOnus,
        ]);
    }
    public function probandoCron(Request $request)
    {
        ini_set('max_execution_time', 360000);
        // *****************************
        $clienteWispro = Clienteswispro::all();
        $clienteSmart = Smart::all();
        $resto = [];
        $switch = 0;
        foreach ($clienteSmart as $smart) {
            $switch = 0;
            foreach ($clienteWispro as $wispro) {
                if ($smart->unique_external_id == $wispro->custom_id) {
                    $switch = 1;
                    break;
                }
            }
            if ($switch == 0) {
                array_push($resto, $smart->unique_external_id);
            }
        }
        return $resto;
        // *****************************
        /*
        date_default_timezone_set("America/La_Paz");
        $mifecha = date('Y-m-d H:i:s');
        $NuevaFechaHora = strtotime('+0 hour', strtotime($mifecha));
        $NuevaFechaMinuteMenos = strtotime('-1 minute', $NuevaFechaHora);
        $NuevaFechaMinute = strtotime('+1 minute', $NuevaFechaHora);
        // $NuevaFechaSecond = strtotime('+30 second', $NuevaFechaMinute);
        $NuevaFechaMenos = date('Y-m-d H:i:s', $NuevaFechaMinuteMenos);
        $NuevaFechaMas = date('Y-m-d H:i:s', $NuevaFechaMinute);


        return response()->json([
            "NuevaFechaMinute1" => $NuevaFechaMenos,
            "NuevaFechaMinute0" => $mifecha,
            "NuevaFechaMinute2" => $NuevaFechaMas,
            // "NuevaFechaMinute" => $NuevaFechaMinute,
            // "NuevaFechaSecond" => $NuevaFechaSecond,
            // "NuevaFecha" => $NuevaFecha,
        ]);
        */
        $fechaActual = date('Y-m-d');
        $fecha = date('Y-m');
        $fecha = str_replace("-", "", $fecha);
        $hora = now();

        $hora_inicio = date('2024-10-16 21:34:02');
        $hora_fin = date('2024-10-16 21:34:28');

        $lista = ListaNegra::where('periodo', $fechaActual)
            ->where('estado', true)
            ->get();
        $lista = ListaNegra::whereBetween('hora_activar_smart', [$hora_inicio, $hora_fin])->get();
        $conta = 1;
        $conta2 = 0;
        $cadena = "";
        $cadenaArray = [];
        for ($i = 0; $i < count($lista); $i++) {
            //$res = Helpers::habilitar_cattv($plan2[$i]);
            //  $conta++;
            // echo $plan2[$i];

            if ($conta > 10) {
                array_push($cadenaArray, $cadena);
                $cadena = "";
                $conta = 1;
                $cadena = $cadena . $lista[$i]->custom_id;
                $conta++;
                $conta2++;
            } else {
                $conta == 1 ? $cadena = $cadena . $lista[$i]->custom_id : $cadena = $cadena . ',' . $lista[$i]->custom_id;
                $conta++;
                $conta2++;
            }
        }

        array_push($cadenaArray, $cadena);
        for ($i = 0; $i < count($cadenaArray); $i++) {
            # code...

            //  $res = Helpers::habilitar_multiple_cattv($cadenaArray[$i]);

            Log::channel('habilitar138')->info($i . '.- Habilitado:' . $cadenaArray[$i]);
            // if ($res['response_code'] === "success") {
            //     Log::channel('habilitar138')->info($i . '.- Habilitado:' . $cadenaArray[$i]);
            // } else {
            //     Log::channel('habilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
            //     $error_habilitados = $cadenaArray[$i];
            // }
        }
        return $cadenaArray;
        $def = [];
        // $def = Helpers::verifica_estado_cattv('213266');
        // return $def;
        foreach ($lista as $lis) {
            # code...

            $resultWiscron = Wisprocron::select('id', 'created_at')->where('custom_id', $lis->custom_id)->count();
            $resultWiscron = Wisprocron::select('id', 'created_at')->where('custom_id', $lis->custom_id)->get();
            $cod_recaudacion = $lis->custom_id . $fecha;
            $resHab =  Helpers::verifica_estado_cattv($lis->custom_id);
            if ($resHab->status) {
                // $activa= ListaNegra::where()->fir
                array_push($def, $resHab);
            }

            /*
            return $resultWiscron->$idDelete->delete();
            if ($estadoYprecio['precio'] > $plan->precio) {
                $resHabiSintesis = Helpers::habilitar_cattv($sint->codigoComprador);
                Log::channel('pagoSintesis')->info("Plan:: " . $estadoYprecio['precio'] . " Y se habilitado CATV a esta hora::> " . now() . " respuestaHabilitar::>" . $resHabiSintesis);
                if ($estadoYprecio['state'] == "disabled") {
                    Log::channel('pagoSintesis')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . "  en CATV ");
                    $resReboot = Helpers::rebootSmart($sint->codigoComprador);

                    Log::channel('pagoSintesis')->info("Se reinicio CATV a esta hora::> " . now() . " por que estaba en un estado::> " . $estadoYprecio['state'] . "  respuestaReinicio::>" . $resReboot);
                } else {

                    Log::channel('pagoSintesis')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . " por eso no se reinicio en CATV " . " respuestaHabilitar::>" . $resHabiSintesis);
                }

                // Helpers::deshabilitar_cattv($cus);
                // eliminar BD Wisprocron 23913a7f-82fa-41a5-ac47-a8b466bd2cbe
                $resultWiscron = Wisprocron::select('id')->where('custom_id', $sint->codigoComprador)->count();
                Log::channel('pagoSintesis')->info("contador " . $resultWiscron);
                if ($resultWiscron > 0) {
                    $resultWiscron = Wisprocron::where('custom_id', $sint->codigoComprador)->first();
                    $periodo = date('Y-m-d');
                    $lista = new ListaNegra();
                    $lista->custom_id = $resultWiscron->custom_id;
                    $lista->name = $resultWiscron->name;
                    $lista->precio = $resultWiscron->precio;
                    $lista->contrato_id = $resultWiscron->contrato_id;
                    $lista->plan_id = $resultWiscron->plan_id;
                    $lista->client_id = $resultWiscron->client_id;
                    //$lista->state_contrato = $resultWiscron->state;
                    $lista->pasarela = "Pago realizado por Sintesis";
                    $lista->periodo = $periodo;
                    $lista->estado = true;
                    $lista->hora_activar_smart = $fechaActual;
                    // $lista->estado_smart = $resultWiscron->;
                    // $lista->descripcion =$resultWiscron->;
                    $lista->save();
                    $idDelete = Wisprocron::find($resultWiscron->id);
                    $idDelete->delete();

                    Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $sint->codigoComprador . " se elimino de la lista negra a esta hora::> " . now());
                } else {
                    Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $sint->codigoComprador . " No esta registrado en la lista negra " . now());
                }
            }
            */
        }
        return $def;
    }
    public function probando(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        ini_set('max_execution_time', 360000);

        $d = new DateTime("2017/12/22");
        return $d;
        /*
        $lista = new ListaNegra();
        $lista->custom_id = "200020";
        $lista->name = "el choco";
        $lista->precio = 20.0;
        $lista->contrato_id = "6546464787";
        $lista->plan_id = "42342342";
        $lista->client_id = "2342342";
        $lista->state_contrato = "enabled";
        $lista->pasarela = "pago por QR";
        $lista->periodo = "2024-10-16";
        $lista->hora_salida_lista_negra = now();
        $lista->hora_activar_smart = now();
        $lista->estado_smart = "habilitado";
        $lista->descripcion = "Error pro";
        $lista->save();

        */
        $fechaActual = date('Y-m-d H:i:s');
        // 210502    213266
        $resultWiscron = Wisprocron::select('id')->where('custom_id', '213290')->count();
        Log::channel('pagoSintesis')->info("contador " . $resultWiscron);
        if ($resultWiscron > 0) {
            $resultWiscron = Wisprocron::where('custom_id', '213290')->first();
            $periodo = date('Y-m-d');
            $lista = new ListaNegra();
            $lista->custom_id = $resultWiscron->custom_id;
            $lista->name = $resultWiscron->name;
            $lista->precio = $resultWiscron->precio;
            $lista->contrato_id = $resultWiscron->contrato_id;
            $lista->plan_id = $resultWiscron->plan_id;
            $lista->client_id = $resultWiscron->client_id;
            //$lista->state_contrato = $resultWiscron->state;
            $lista->pasarela = "Pago realizado por Sintesis";
            $lista->periodo = $periodo;
            $lista->estado = true;
            $lista->hora_activar_smart = $fechaActual;
            // $lista->estado_smart = $resultWiscron->;
            // $lista->descripcion =$resultWiscron->;
            $lista->save();
            $idDelete = Wisprocron::find($resultWiscron->id);
            $idDelete->delete();

            Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $resultWiscron->codigoComprador . " se elimino de la lista negra a esta hora::> " . now());
        } else {
            Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $resultWiscron->codigoComprador . " No esta registrado en la lista negra " . now());
        }
        return $lista;

        // Artisan::call('app:volver-habilitar-catv', ['hora' => $hora]);
        Artisan::command('app:volver-habilitar-catv {hora} {--force}', function ($hora) {
            // ...
        })->everyTwoMinutes();

        // Schedule::command('app:volver-habilitar-catv')
        //     ->timezone('America/New_York')
        //     ->at('2:00');
        // Schedule::command('app:volver-habilitar-catv')->daily();
        //exec('php artisan app:volver-habilitar-catv > /dev/null &');
        // for ($i = 0; $i < 200; $i++) {\Log::info($i . " Mi cron " . now());
        //     sleep(5);}
        /*
        try {
            $text = "200020,200040,200050,200042";
            $res = Helpers::deshabilitar_multiple_cattv($text);
            if ($res['response_code'] === "success") {
                Log::channel('habilitar138')->error('Deshabilitado:' . $text);
            } else {
                Log::channel('habilitar138')->error('Error en estos ids:' . $text);
            }
            //$res = Helpers::habilitar_multiple_cattv($text);
            return $res['response_code'];
        } catch (\Exception $e) {
            //throw $th;
            return $e;
        }
*/
        // 200050  technologies CT1  3dd62cc8-c0c4-4148-b104-373b57d39cf3  cc96e95f-5559-48a2-9f95-afe4cb20f4ba   23913a7f-82fa-41a5-ac47-a8b466bd2cbe  -16.548573  -68.075125   disabled   0
        try {
            //code...
            // ->orderBy('name', 'desc')
            /*
            $users = DB::table('sintesis')
                // ->whereYear('created_at', '2024')
                ->whereMonth('created_at', '09')
                // ->whereDay('created_at', '>=', '01')
                ->get();
            return $users;
            */
            // $orders = Sintesi::whereYear('created_at', '2024')
            //     ->whereMonth('created_at', '08')
            //     ->whereDay('created_at', '>=', '01')
            //     ->get();
            // return $orders;
            // 2024-08-01 15:18:31

            $precio = 138;
            $startDate = '2024-09-01';
            $endDate = '2024-09-20';
            $orders = Sintesi::whereBetween('created_at', [$startDate, $endDate])->get();
            $plan2 = [];
            foreach ($orders as $plan) {

                if ($plan['montoPago'] == $precio) {
                    $plan2[] = intval($plan['codigoComprador']);
                }
            }
            //return $plan2;
            // Habilitamos
            $conta = 1;
            $conta2 = 0;
            $cadena = "";
            $cadenaArray = [];
            // deshabilitar_cattv
            //  $res = Helpers::deshabilitar_multiple_cattv("200020");
            Log::channel('habilitar138')->info('Este mensaje se registrará en habilitar138.log');
            Log::channel('habilitar138')->error('Este mensaje se registrará en habilitar138.log');
            // $res['status'];
            //  return $res;
            for ($i = 0; $i < count($plan2); $i++) {
                //$res = Helpers::habilitar_cattv($plan2[$i]);
                //  $conta++;
                // echo $plan2[$i];

                if ($conta > 10) {
                    array_push($cadenaArray, $cadena);
                    $cadena = "";
                    $conta = 1;
                    $cadena = $cadena . $plan2[$i];
                    $conta++;
                    $conta2++;
                } else {
                    $conta == 1 ? $cadena = $cadena . $plan2[$i] : $cadena = $cadena . ',' . $plan2[$i];
                    $conta++;
                    $conta2++;
                }
            }
            array_push($cadenaArray, $cadena); // aqui tenemos en 1 item 10 custom id

            /*
            $ii = 0;
            $error_habilitados = [];
            $error_deshabilitados = [];
            // habilitamos
            for ($i = 0; $i < count($cadenaArray); $i++) {
                # code...

                $res = Helpers::habilitar_multiple_cattv($cadenaArray[$i]);

                if ($res['response_code'] === "success") {
                    Log::channel('habilitar138')->error($i . '.- Habilitado:' . $cadenaArray[$i]);
                } else {
                    Log::channel('habilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                    $error_habilitados = $cadenaArray[$i];
                }
                // sleep(2);
            }
            // return $error_habilitados;
            if (count($error_habilitados) > 0) {
                for ($i = 0; $i < count($error_habilitados); $i++) {
                    # code...

                    $res = Helpers::habilitar_multiple_cattv($error_habilitados[$i]);
                    $ii++;
                    if ($res['response_code'] === "success") {
                        Log::channel('habilitar138')->error($i . '.- Habilitado:' . $error_habilitados[$i]);
                    } else {
                        Log::channel('habilitar138')->error($i . '.- Error en estos ids:' . $error_habilitados[$i]);
                        //$error_habilitados = $cadenaArray[$i];
                    }
                    sleep(2);
                }
            }
            */
            // deshabilitamos
            for ($i = 0; $i < count($cadenaArray); $i++) {
                $res = Helpers::deshabilitar_multiple_cattv($cadenaArray[$i]);

                if ($res['response_code'] === "success") {
                    Log::channel('deshabilitar138')->error($i . '.- Deshabilitado:' . $cadenaArray[$i]);
                } else {
                    Log::channel('deshabilitar138')->error($i . '.- Error en estos ids:' . $cadenaArray[$i]);
                    $error_deshabilitados = $cadenaArray[$i];
                }
                // sleep(2);
            }
            /*
            if (count($error_deshabilitados) > 0) {
                for ($i = 0; $i < count($error_deshabilitados); $i++) {
                    # code...

                    $res = Helpers::habilitar_multiple_cattv($error_deshabilitados[$i]);
                    $ii++;
                    if ($res['response_code'] === "success") {
                        Log::channel('deshabilitar138')->error($i . '.- Habilitado:' . $error_deshabilitados[$i]);
                    } else {
                        Log::channel('deshabilitar138')->error($i . '.- Error en estos ids:' . $error_deshabilitados[$i]);
                        //$error_habilitados = $cadenaArray[$i];
                    }
                    sleep(2);
                }
            }
            */
            // return $cadenaArray;
            return response()->json([
                "conta2" => $conta2,
                "cadena" => $cadena,
                "cantPlan" => count($plan2),
                "cant" => count($cadenaArray),
                // "ii" => $ii,
                "data" => $cadenaArray,
            ]);
        } catch (\Exception $e) {
            //throw $th;
            return $e;
        }
        // 1er filtro rescatar de wispro todos los clientes con el plan 138
        // 2do filtro rescatar todos los clientes de wispro que no tengan el plan de 138 pero que tengan la condicion de deshabilitados
        // 3er filtro rescatar de  SmartOlt todos los clientes que sean de los 4 modelos
        // 4to solo hacer correr de los rescatados de wispro a esos equipos que tenga los 4 modelos

        /*
        $planesFull = Helpers::obtenerTodosLosPlanesWispro();
        $precio = 138;
        $plan2 = [];
        foreach ($planesFull['data'] as $plan) {

            if ($plan['price'] == $precio) {
                array_push($plan2, $plan);
            }
        }
        $idPlan = $plan2[0]['id'];
        $namePlan = $plan2[0]['name'];
        return $TodosLosClientesWispro;
        $TodosLosClientesWispro = Helpers::obtenerTodosLosContratosWispro($idPlan);
        */
    }
}
