<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('imagen_qrs', function (Blueprint $table) {
            $table->id();
            $table->text('custom_id')->nullable();
            $table->dateTime('createDate')->nullable();
            $table->string('periodo')->nullable();
            $table->string('montoMes');
            $table->integer('estado'); // 0= en proceso 1= pagado
            $table->text('imageQr');

            // 1=No Usado; 2=Usado 3=Expirado; 4=Con error 5= eliminado
            $table->integer('statusId')->default(1)->nullable();
            $table->integer('activo'); //1=qrActivo 2=qrInActivo

            $table->dateTime('expirationDate')->nullable();
            $table->string('mensaje')->nullable();
            // $table->string('voucherId')->default(0)->nullable();



            $table->bigInteger('qr_id')->unsigned();
            $table->foreign('qr_id')->references('id')->on('qrs');
            $table->bigInteger('client_id')->unsigned();
            $table->foreign('client_id')->references('id')->on('clients')->onDelete('cascade');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('imagen_qrs');
    }
};
