<?php

namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * Define the application's command schedule.
     */
    protected function schedule(Schedule $schedule): void
    {
        // $schedule->command('inspire')->hourly();
        // $schedule->command('demo:cron')
        //     ->timezone('America/La_Paz')->dailyAt('17:30');

        $schedule->command('sist:cron')
            ->timezone('America/La_Paz')->dailyAt('22:13');

        $schedule->command('app:delete-task')
            ->timezone('America/La_Paz')->everyMinute();
        $schedule->command('app:prueba')
            ->timezone('America/La_Paz')->dailyAt('22:13');
        $schedule->command('app:volver-habilitar-catv')
            ->timezone('America/La_Paz')->dailyAt('20:10');
    }

    /**
     * Register the commands for the application.
     */
    protected function commands(): void
    {
        $this->load(__DIR__ . '/Commands');

        require base_path('routes/console.php');
    }
}
