<?php

namespace App\Http\Controllers;

use App\Models\Mensaje;
use Illuminate\Http\Request;

class MensajeController extends Controller
{
    //
    public function index()
    {
        //
        $this->authorize("viewAny_user");

        // $usuarios = User::with('roles')->paginate(10);
        // $usuarios = User::paginate(10);
        $mensajes = Mensaje::get();
        return response()->json([
            "status" => true,
            "mensajes" => $mensajes
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //


        $this->authorize("create_user");

        // validar
        $request->validate([
            "nombre" => "required",
            "page" => "required",
            "mensaje" => "required"
        ]);
        // guardar como objeto
        $mensaje = new Mensaje();
        $mensaje->nombre = $request->nombre;
        $mensaje->page = $request->page;
        $mensaje->mensaje = $request->mensaje;

        $mensaje->save();
        // responder
        return response()->json([
            "status" => true,
            "mensaje" => "Mensaje registrado correctamente"
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
        $this->authorize("show_user");

        $mensaje = Mensaje::find($id);
        return response()->json([
            "status" => true,
            "usuario" => $mensaje
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
        $this->authorize("update_user");
        // validar
        $request->validate([
            "nombre" => "required",
            "page" => "required",
            "mensaje" => "required"
        ]);
        // modificar
        $mensaje = Mensaje::find($id);

        $mensaje->nombre = $request->nombre;
        $mensaje->page = $request->page;
        $mensaje->mensaje = $request->mensaje;
        $mensaje->update();
        // responder
        return response()->json([
            "status" => true,
            "mensaje" => "Mensaje modificado correctamente"
        ], 200);
    }
}
