<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('sintesis', function (Blueprint $table) {
            $table->id();
            $table->string('transaccion', 1); //String  ==> A=Alta, M=Modificación, B=Baja Determina si es un registro de recaudación nuevo (A), si se va a modificar (M) o dar de baja (B).
            $table->string('nombreComprador'); //String Nombre de la persona que registra la solicitud de compra
            $table->string('documentoIdentidadComprador', 255); //String
            $table->string('codigoComprador', 255); //Código de Comprador Codigo de cliente String
            $table->integer('fecha'); // <fecha>20231113</fecha>
            $table->integer('hora'); // <fecha>20231113</fecha>
            $table->string('correoElectronico', 255); //
            $table->string('moneda')->default('BS'); //String BS
            $table->string('descripcionRecaudacion'); //String
            $table->string('codigoRecaudacion', 255)->unique(); //String Codigo de recaudación, codigo único para la empresa. Longitud máxima 15 caracteres
            // $table->integer('fechaVencimiento')->default(0); // <fecha>20231113</fecha>
            // $table->integer('horaVencimiento')->default(0); // <fecha>20231113</fecha>

            $table->string('categoriaProducto')->default(1); //Integer// Como es efectivo boliviano siempre es 1
            // Planillas
            $table->integer('numeroPago')->default(1); //Integer Numero del pago por recaudación, secuencial 1, 2, 3,         N

            $table->double('montoPago'); //Double
            $table->string('descripcion'); //String Descripcion del pago
            $table->double('montoCreditoFiscal'); //Double
            $table->string('nombreFactura'); //
            $table->string('nitFactura'); //

            $table->string('idTransaccion')->nullable(); //
            $table->integer('codigoError')->nullable(); //
            $table->string('descripcionError')->nullable(); //
            $table->integer('codigoErrorItem')->nullable(); //
            $table->string('descripcionErrorItem')->nullable(); //

            $table->integer('status')->default(1)->nullable(); //Activo 1 Desactivo 0
            $table->integer('activo')->default(1)->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('sintesis');
    }
};
