<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('pago_detalles', function (Blueprint $table) {
            $table->id();

            $table->string('nombreComprador'); //String Nombre de la persona que registra la solicitud de compra
            $table->string('codigoRecaudacion', 255); //String Codigo de recaudación, codigo único para la empresa. Longitud máxima 15 caracteres
            $table->string('documentoIdentidadComprador', 255)->nullable(); //String
            $table->string('codigoComprador', 255); //Código de Comprador Codigo de cliente String                        
            $table->string('descripcionRecaudacion')->nullable(); //String                       

            $table->double('montoPago'); //Double                


            $table->string('idTransaccion')->nullable(); //
            $table->integer('codigoError')->nullable(); //
            $table->string('descripcionError')->nullable(); //
            $table->integer('codigoErrorItem')->nullable(); //
            $table->string('descripcionErrorItem')->nullable(); //
            $table->string('transaccion'); //
            $table->integer('fechaPagoSintesis'); //
            $table->integer('horaPagoSintesis'); //
            $table->double('montoPagoSintesis'); //
            $table->string('nroRentaReciboSintesis'); //

            $table->integer('status')->default(0)->nullable(); //Activo 1 Desactivo 0
            $table->integer('activo')->default(0)->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('pago_detalles');
    }
};
